﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Machr_Prezentace
{
    public partial class Form1 : Form
    {
        /*
            Bohuzel napovedu jsem nestihl, tak to aspon napisi do komentu.
            Kdyz budes chtit upravit text nebo pozadi, klikni na nej pravim a zobrazi se ti moznosti.
            Kdyz budes chtit posunout text, staci na nej kliknout a hybnout mysi.
            */

        List<Snimek> snimky = new List<Snimek>();
        Snimek oznacenySnimek;

        ListViewItem oznacenyItem;

        Control oznacenyText;
        Control oznacenyObrazek;
        Point poziceMysi;

        public Form1()
        {
            InitializeComponent();

            //pridani prvniho snimku
            PridejSnimek();
            oznacenySnimek = snimky[0];
            oznacenyItem = listView.Items[0];
        }

        //-----------------------------------------------------------------------------------ListView
        private void listView_ItemSelectionChanged(object sender, ListViewItemSelectionChangedEventArgs e)
        {
            oznacenyItem = listView.Items[e.ItemIndex];
            oznacenySnimek = snimky[e.ItemIndex];
        }

        private void novySlideToolStripMenuItem_Click(object sender, EventArgs e)
        {
            PridejSnimek();
        }

        private void smazatToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (listView.Items.Count > 0 && oznacenyItem != null)
            {
                snimky.RemoveAt(listView.Items.IndexOf(oznacenyItem));
                oznacenySnimek = snimky[listView.Items.IndexOf(oznacenyItem)];

                imageList.Images.RemoveAt(listView.Items.IndexOf(oznacenyItem)); // mazani obrazku (jinak by se hromadili)
                listView.Items.Remove(oznacenyItem);

                oznacenyItem = null;

                for (int i = 0; i < listView.Items.Count; i++) // znova nastaveni ImageIndexu a cisla snimkum
                {
                    listView.Items[i].ImageIndex = i;
                    listView.Items[i].Text = (i + 1).ToString();
                }
            }
        }

        private void duplikovatToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Snimek snimek = oznacenySnimek;
            snimky.Add(snimek);

            ListViewItem item = new ListViewItem();
            item.ImageIndex = listView.Items.Count;
            item.Text = (imageList.Images.Count + 1).ToString();

            imageList.Images.Add(Image.FromFile("prezentace/prezentace01/steam.png"));
            listView.Items.Add(item);
        }

        //-----------------------------------------------------------------------------------Kontrolky
        private void text_MouseDown(object sender, MouseEventArgs e)
        {
            if(e.Button == MouseButtons.Left)
                poziceMysi = e.Location;

            oznacenyText = (Control)sender;
        }

        private void text_MouseUp(object sender, MouseEventArgs e)
        {
            if(e.Button != MouseButtons.Right)
                oznacenyText = null;
        }

        private void text_MouseMove(object sender, MouseEventArgs e)
        {
            if(e.Button == MouseButtons.Left)
            {
                oznacenyText.Left = e.X + oznacenyText.Left - poziceMysi.X;
                oznacenyText.Top = e.Y + oznacenyText.Top - poziceMysi.Y;
            }
        }

        private void obrazek_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
                poziceMysi = e.Location;

            oznacenyObrazek = (Control)sender;
        }

        private void obrazek_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button != MouseButtons.Right)
                oznacenyObrazek = null;
        }

        private void obrazek_MouseMove(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                oznacenyObrazek.Left = e.X + oznacenyObrazek.Left - poziceMysi.X;
                oznacenyObrazek.Top = e.Y + oznacenyObrazek.Top - poziceMysi.Y;
            }
        }

        private void smazatToolStripMenuItem2_Click(object sender, EventArgs e)
        {
            // smazani kontrolky
            panel.Controls.Remove(oznacenyText);
        }

        private void vlastnostiToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            // zobrazeni okna vlastnosti u kontrolky
            VlastnostiText vst = new VlastnostiText(oznacenyText);
            vst.Show();
        }


        //------------------------------------------------------------------------------------ToolStrip
        private void konecToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        //------------------------------------------------------------------------------------ContextMenuStrip: PANEL
        private void textToolStripMenuItem_Click(object sender, EventArgs e) // pridani textu
        {
            Label label = new Label();

            label.BackColor = Color.Transparent;
            label.AutoSize = true;
            label.Location = new Point(panel.Width / 2, panel.Height / 2);
            label.ContextMenuStrip = contextMenuStrip_text;
            label.Name = "label";
            label.Text = "Text";
            label.MouseDown += new MouseEventHandler(text_MouseDown);
            label.MouseUp += new MouseEventHandler(text_MouseUp);
            label.MouseMove += new MouseEventHandler(text_MouseMove);

            panel.Controls.Add(label);

            snimky[listView.Items.IndexOf(oznacenyItem)].PridejKontrolku(label);
        }

        private void duplikovatToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            Label label = new Label();

            label.BackColor = Color.Transparent;
            label.ForeColor = oznacenyText.ForeColor;
            label.AutoSize = true;
            label.Location = new Point(panel.Width / 2, panel.Height / 2);
            label.ContextMenuStrip = contextMenuStrip_text;
            label.Name = "label";
            label.Text = oznacenyText.Text;
            label.Font = oznacenyText.Font;
            label.MouseDown += new MouseEventHandler(text_MouseDown);
            label.MouseUp += new MouseEventHandler(text_MouseUp);
            label.MouseMove += new MouseEventHandler(text_MouseMove);

            panel.Controls.Add(label);
        }

        private void obrázekToolStripMenuItem_Click(object sender, EventArgs e) // pridani obrazku
        {
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                PictureBox pb = new PictureBox();

                pb.Image = Image.FromFile(openFileDialog.FileName);
                pb.Size = new Size(pb.Image.Width, pb.Image.Height);
                pb.Location = new Point(panel.Width / 2, panel.Height / 2);pb.
                pb.MouseDown += new MouseEventHandler(obrazek_MouseDown);
                pb.MouseUp += new MouseEventHandler(obrazek_MouseUp);
                pb.MouseMove += new MouseEventHandler(obrazek_MouseMove);

                panel.Controls.Add(pb);
            }
        }

        private void vlastnostiToolStripMenuItem_Click(object sender, EventArgs e) // vlastnosti panelu
        {
            Console.WriteLine(oznacenySnimek.BarvyPozadi.Colors[0]);
            VlastnostiSnimek vst = new VlastnostiSnimek(panel, oznacenySnimek);
            vst.Show();
        }

        //------------------------------------------------------------------------------------Vlastni metody
        private void PridejSnimek()
        {
            snimky.Add(new Snimek());

            ListViewItem item = new ListViewItem();
            item.ImageIndex = listView.Items.Count;
            item.Text = (imageList.Images.Count + 1).ToString();

            imageList.Images.Add(Image.FromFile("prezentace/prezentace01/steam.png"));
            listView.Items.Add(item);
        }
    }
}
