﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Machr_Prezentace
{
    public class Snimek
    {
        List<Control> kontrolky = new List<Control>();

        bool verticalne = true;
        bool prohozeneBarvy = false;
        int rotacePozadiBarvy = 0;

        public ColorBlend BarvyPozadi { get; set; }

        public Snimek()
        {
            BarvyPozadi = new ColorBlend();

            Color[] poleBarev = { Color.Red , Color.Blue , Color.Black};
            BarvyPozadi.Colors = poleBarev;

            float[] poleFloat = { 0, 0.5f , 1};
            BarvyPozadi.Positions = poleFloat;
        }

        public Snimek(ColorBlend barvyPozadi, bool verticalne, bool prohozeneBarvy, int rotacePozadiBarvy)
        {
            BarvyPozadi = barvyPozadi;
            this.verticalne = verticalne;
            this.prohozeneBarvy = prohozeneBarvy;
            this.rotacePozadiBarvy = rotacePozadiBarvy;
        }

        public void NastavHodnoty(ColorBlend barvyPozadi, bool verticalne, bool prohozeneBarvy, int rotacePozadiBarvy)
        {
            BarvyPozadi = barvyPozadi;
            this.verticalne = verticalne;
            this.prohozeneBarvy = prohozeneBarvy;
            this.rotacePozadiBarvy = rotacePozadiBarvy;
        }

        public void PridejKontrolku(Control kontrolka)
        {
            kontrolky.Add(kontrolka);
        }

        public ColorBlend VratVytvorenyColorBlend(ColorBlend coloBlend)
        {
            ColorBlend vytvColorBlend = new ColorBlend();

            vytvColorBlend.Colors = coloBlend.Colors;
            vytvColorBlend.Positions = coloBlend.Positions;

            return vytvColorBlend;
        }

        public int VratRotaciBarev()
        {
            return rotacePozadiBarvy;
        }

        public bool VratOrientaciBarev()
        {
            return verticalne;
        }

        public bool VratProhozeniBarvy()
        {
            return prohozeneBarvy;
        }
    }
}
