﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Machr_Prezentace
{
    public partial class VlastnostiSnimek : Form
    {
        Panel panel;

        Snimek snimek;
        Snimek ulozenySnimek;

        ColorBlend colorBlend;

        ListViewItem oznacenyItem;

        Graphics g;

        public VlastnostiSnimek(Panel panel, Snimek snimek)
        {
            InitializeComponent();

            this.panel = panel;
            this.snimek = snimek;
            ulozenySnimek = new Snimek(snimek.VratVytvorenyColorBlend(snimek.BarvyPozadi), snimek.VratOrientaciBarev(), snimek.VratProhozeniBarvy(), snimek.VratRotaciBarev());
            colorBlend = snimek.BarvyPozadi;

            panel.Paint += new PaintEventHandler(pictureBox_pozadi_Paint);

            numericUpDown_pozice.Increment = 0.1M;
            checkBox_prohoditBarvy.Checked = snimek.VratProhozeniBarvy();

            pictureBox_barva.BackColor = colorBlend.Colors[0];
            Console.WriteLine(colorBlend.Positions[1]);

            for (int i = 0; i < colorBlend.Colors.Length; i++)
            {
                ListViewItem item = new ListViewItem();

                item.Text = colorBlend.Colors[i].R.ToString() + "; " + colorBlend.Colors[i].G.ToString() + "; " + colorBlend.Colors[i].B.ToString();
                item.SubItems.Add(colorBlend.Positions[i].ToString());

                listView.Items.Add(item);
            }

            if(snimek.VratOrientaciBarev()) // toto musi byt zde, protoze se meni hodnota -> vola se: comboBox_SelectedIndexChanged
                comboBox.SelectedIndex = 0;
            else
                comboBox.SelectedIndex = 1;

            oznacenyItem = listView.Items[0];
        }

        //-----------------------------------------------------------------------------------Kontrolky
        private void listView_ItemSelectionChanged(object sender, ListViewItemSelectionChangedEventArgs e)
        {
            if (e.ItemIndex < listView.Items.Count) // podminka: po smazani se tato metoda spusti. Pokud byla smazana posledni barva, e.ItemIndex byl mimo hranice pole
            {
                oznacenyItem = listView.Items[e.ItemIndex];
                numericUpDown_pozice.Value = decimal.Parse(oznacenyItem.SubItems[1].Text);

                Console.WriteLine("barva");
                pictureBox_barva.BackColor = colorBlend.Colors[e.ItemIndex];
            }
            else
                oznacenyItem = listView.Items[listView.Items.Count - 1];
        }

        private void numericUpDown_pozice_ValueChanged(object sender, EventArgs e)
        {
            //osetreni, aby pocet pozic na 0 nebo 1 byl vetsi nebo rovno 1...
            if (decimal.Parse(listView.Items[listView.Items.IndexOf(oznacenyItem)].SubItems[1].Text) == 0 && numericUpDown_pozice.Value != 0) // pokud ma oznacena barva pozici 0 a je jedina, probehne return
            {
                bool vPoradku;
                OtestujPozice(0, 1, out vPoradku);

                if (!vPoradku)
                {
                    numericUpDown_pozice.Value = 0;
                    return;
                }
            }
            else if (decimal.Parse(listView.Items[listView.Items.IndexOf(oznacenyItem)].SubItems[1].Text) == 1 && numericUpDown_pozice.Value != 1)
            {
                bool vPoradku;
                OtestujPozice(1, 1, out vPoradku);

                if (!vPoradku)
                {
                    numericUpDown_pozice.Value = 1;
                    return;
                }

            }
            //...osetreni, aby pocet pozic na 0 nebo 1 byl vetsi nebo rovno 1
            Console.WriteLine(numericUpDown_pozice.Value.ToString());

            listView.Items[listView.Items.IndexOf(oznacenyItem)].SubItems[1].Text = numericUpDown_pozice.Value.ToString();

            // serazovani: posouvani itemu dolu
            if (listView.Items.IndexOf(oznacenyItem) < listView.Items.Count - 1)
            {
                ListViewItem item;

                while (decimal.Parse(listView.Items[listView.Items.IndexOf(oznacenyItem)].SubItems[1].Text) > decimal.Parse(listView.Items[listView.Items.IndexOf(oznacenyItem) + 1].SubItems[1].Text))
                {
                    item = listView.Items[listView.Items.IndexOf(oznacenyItem) + 1];
                    listView.Items.Remove(item);
                    listView.Items.Insert(listView.Items.IndexOf(oznacenyItem), item);

                    if (listView.Items.IndexOf(oznacenyItem) == listView.Items.Count - 1)
                        break;
                }
            }

            // serazovani: posouvani itemu nahoru
            if (listView.Items.IndexOf(oznacenyItem) > 0)
            {
                ListViewItem item;

                while (decimal.Parse(listView.Items[listView.Items.IndexOf(oznacenyItem)].SubItems[1].Text) < decimal.Parse(listView.Items[listView.Items.IndexOf(oznacenyItem) - 1].SubItems[1].Text))
                {
                    item = listView.Items[listView.Items.IndexOf(oznacenyItem) - 1];
                    listView.Items.Remove(item);
                    listView.Items.Insert(listView.Items.IndexOf(oznacenyItem) + 1, item);

                    if (listView.Items.IndexOf(oznacenyItem) == 0)
                        break;
                }
            }

            NastavBarvuPozadi();
        }

        private void comboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            NastavBarvuPozadi();
        }

        private void checkBox_prohoditBarvy_CheckedChanged(object sender, EventArgs e)
        {
            NastavBarvuPozadi();
        }

        private void pictureBox_barva_Click(object sender, EventArgs e)
        {
            if (colorDialog.ShowDialog() == DialogResult.OK)
            {

                pictureBox_barva.BackColor = colorDialog.Color;

                colorBlend.Colors[listView.Items.IndexOf(oznacenyItem)] = colorDialog.Color;
                listView.Items[listView.Items.IndexOf(oznacenyItem)].Text = colorDialog.Color.R.ToString() + "; " + colorDialog.Color.G.ToString() + "; " + colorDialog.Color.B.ToString();

                NastavBarvuPozadi();
            }
        }

        //-----------------------------------------------------------------------------------Buttons
        private void bttn_pridat_Click(object sender, EventArgs e)
        {
            // pridani barvy...
            Color[] barvy = new Color[listView.Items.Count + 1];
            float[] pozice = new float[listView.Items.Count + 1];

            for (int i = 0; i < barvy.Length; i++) // prida na pozici 0 bilou barvu a ostatni posune
            {
                if (i != 0)
                {
                    barvy[i] = colorBlend.Colors[i - 1];
                    pozice[i] = colorBlend.Positions[i - 1];
                }
                else
                {
                    barvy[0] = Color.White;
                    pozice[0] = 0;
                }
            }

            colorBlend.Colors = barvy;
            colorBlend.Positions = pozice;
            //...pridani barvy

            ListViewItem item = new ListViewItem();

            item.Text = colorBlend.Colors[0].R.ToString() + "; " + colorBlend.Colors[0].G.ToString() + "; " + colorBlend.Colors[0].B.ToString();
            item.SubItems.Add(colorBlend.Positions[0].ToString());

            listView.Items.Insert(0, item); // da item na misto 0 a vsechny zbyvajici posune

            NastavBarvuPozadi();
        }

        private void bttn_smazat_Click(object sender, EventArgs e)
        {
            if(listView.Items.Count == 2)
            {
                MessageBox.Show("Počet barev musí být větší nebo rovno 2.", "Vlastnosti snímku", MessageBoxButtons.OK);
                return;
            }

            if(decimal.Parse(listView.Items[listView.Items.IndexOf(oznacenyItem)].SubItems[1].Text) == 0 || decimal.Parse(listView.Items[listView.Items.IndexOf(oznacenyItem)].SubItems[1].Text) == 1)
            {
                bool poziceVPoradku;
                OtestujPozice(Convert.ToInt32(decimal.Parse(listView.Items[listView.Items.IndexOf(oznacenyItem)].SubItems[1].Text)), 2, out poziceVPoradku);

                if (!poziceVPoradku) // pokud je jedna barva majici 0 nebo 1
                    return;
            }

            // smazani barvy...
            Color[] barvy = new Color[listView.Items.Count - 1];
            float[] pozice = new float[listView.Items.Count - 1];

            for (int i = 0; i < barvy.Length; i++)
            {
                if (i < listView.Items.IndexOf(oznacenyItem))
                {
                    barvy[i] = colorBlend.Colors[i];
                    pozice[i] = colorBlend.Positions[i];
                }
                else
                {
                    barvy[i] = colorBlend.Colors[i + 1];
                    pozice[i] = colorBlend.Positions[i + 1];
                }
            }
            listView.Items[listView.Items.IndexOf(oznacenyItem)].Remove();

            colorBlend.Colors = barvy;
            colorBlend.Positions = pozice;
            //...smazani barvy

            NastavBarvuPozadi();
        }

        private void bttn_ok_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void bttn_cancel_Click(object sender, EventArgs e)
        {
            snimek.NastavHodnoty(ulozenySnimek.BarvyPozadi, ulozenySnimek.VratOrientaciBarev(), ulozenySnimek.VratProhozeniBarvy(), ulozenySnimek.VratRotaciBarev());

            colorBlend = ulozenySnimek.BarvyPozadi;
            panel.Refresh();

            Close();
        }

        //-----------------------------------------------------------------------------------Vlastni metody
        private void OtestujPozice(int pozadovaneCislo, int minimalniPocet, out bool vPoradku)
        {
            vPoradku = true;

            int pocetItemuSPoziciNula = 0;
            int pocetItemuSPoziciJedna = 0;

            foreach (ListViewItem item in listView.Items)
            {
                if (decimal.Parse(item.SubItems[1].Text) == 0)
                    pocetItemuSPoziciNula++;
                else if (decimal.Parse(item.SubItems[1].Text) == 1)
                    pocetItemuSPoziciJedna++;
            }

            if (pocetItemuSPoziciNula < minimalniPocet && (pozadovaneCislo == 0 || pozadovaneCislo == 3)/* && (pozadovaneCislo == 0 || pozadovaneCislo == 3)*/)
            {
                //Console.WriteLine("0: " + pocetItemuSPoziciNula);
                MessageBox.Show("Počet barev majicí pozici 0 musí být větší nebo roven 1", "Vlastnosti snímku", MessageBoxButtons.OK);
                vPoradku = false;
            }
            if (pocetItemuSPoziciJedna < minimalniPocet && (pozadovaneCislo == 1 || pozadovaneCislo == 3)/*2 && (pozadovaneCislo == 1 || pozadovaneCislo == 3)*/)
            {
                //Console.WriteLine("1: " + pocetItemuSPoziciJedna);
                MessageBox.Show("Počet barev majicí pozici 1 musí být větší nebo roven 1", "Vlastnosti snímku", MessageBoxButtons.OK);
                vPoradku = false;
            }
        }

        private void NastavBarvuPozadi()
        {
            //znova nastaveni barev a pozic
            Color[] barvy = new Color[listView.Items.Count];
            float[] pozice = new float[listView.Items.Count];

            for (int i = 0; i < listView.Items.Count; i++)
            {
                string txtBarvy = listView.Items[i].Text;
                txtBarvy = txtBarvy.Replace(" ", "");

                string[] hodnotaRGB = txtBarvy.Split(';');

                barvy[i] = Color.FromArgb(int.Parse(hodnotaRGB[0]), int.Parse(hodnotaRGB[1]), int.Parse(hodnotaRGB[2]));
                pozice[i] = float.Parse(listView.Items[i].SubItems[1].Text);
            }

            colorBlend.Colors = barvy;
            colorBlend.Positions = pozice;

            panel.Invalidate();
        }

        //-----------------------------------------------------------------------------------Ostatni metody
        private void pictureBox_pozadi_Paint(object sender, PaintEventArgs e)
        {
            Point point1 = new Point();
            Point point2 = new Point();

            if (comboBox.SelectedIndex == 1)
            {
                if (checkBox_prohoditBarvy.Checked)
                {
                    point1.X = 0;
                    point1.Y = panel.Height;

                    point2.X = 0;
                    point2.Y = 0;
                }
                else
                {
                    point1.X = 0;
                    point1.Y = 0;

                    point2.X = 0;
                    point2.Y = panel.Height;
                }
            }
            else
            {
                if (checkBox_prohoditBarvy.Checked)
                {
                    point1.X = panel.Width;
                    point1.Y = 0;

                    point2.X = 0;
                    point2.Y = 0;
                }
                else
                {
                    point1.X = 0;
                    point1.Y = 0;

                    point2.X = panel.Width;
                    point2.Y = 0;
                }
            }

            LinearGradientBrush brush = new LinearGradientBrush(point1, point2, colorBlend.Colors[0], colorBlend.Colors[0]);

            brush.InterpolationColors = colorBlend;

            g = e.Graphics;
            g.FillRectangle(brush, 0, 0, panel.Width, panel.Height);
            //e.Graphics.FillRectangle(brush, 0, 0, panel.Width, panel.Height);
        }
    }
}
