﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Machr_Prezentace
{
    public partial class VlastnostiText : Form
    {
        Control kontrolka;

        string text;
        Color barva;
        Font font;

        bool tucne;
        bool kurziva;
        bool podtrzeni;
        bool preskrtnuti;

        public VlastnostiText(Control kontrolka)
        {
            InitializeComponent();

            this.kontrolka = kontrolka;

            // ulozeni pro pripad Cancelu
            text = kontrolka.Text;
            barva = kontrolka.ForeColor;
            font = kontrolka.Font;

            tucne = font.Bold;
            kurziva = font.Italic;
            podtrzeni = font.Underline;
            preskrtnuti = font.Strikeout;


            // nastaveni vlastnosti kontrolkam, jaky ma label font
            textBox_text.Text = kontrolka.Text;
            pictureBox.BackColor = barva;

            numericUpDown_velikost.Value = (decimal)font.Size;
            checkBox_tucne.Checked = font.Bold;
            checkBox_kurziva.Checked = font.Italic;
            checkBox_podtrzeni.Checked = font.Underline;
            checkBox_preskrtnuti.Checked = font.Strikeout;
        }

        //------------------------------------------------------------------------------------Buttons
        private void bttn_vybratBarvu_Click(object sender, EventArgs e)
        {
            colorDialog.Color = barva;
            colorDialog.ShowDialog();

            pictureBox.BackColor = colorDialog.Color;
            kontrolka.ForeColor = colorDialog.Color;
        }

        private void bttn_zmenitFont_Click(object sender, EventArgs e)
        {
            fontDialog.Font = kontrolka.Font;

            if (fontDialog.ShowDialog() == DialogResult.OK)
            {

                numericUpDown_velikost.Value = (decimal)fontDialog.Font.Size;
                checkBox_tucne.Checked = fontDialog.Font.Bold;
                checkBox_kurziva.Checked = fontDialog.Font.Italic;
                checkBox_podtrzeni.Checked = fontDialog.Font.Underline;
                checkBox_preskrtnuti.Checked = fontDialog.Font.Strikeout;

                kontrolka.Font = fontDialog.Font;
            }
        }

        private void bttn_cancel_Click(object sender, EventArgs e)
        {
            kontrolka.Text = text;
            kontrolka.Font = font;
            kontrolka.ForeColor = barva;

            Close();
        }

        private void bttn_ok_Click(object sender, EventArgs e)
        {
            Close();
        }

        //------------------------------------------------------------------------------------Kontrolky
        private void textBox_text_TextChanged(object sender, EventArgs e)
        {
            kontrolka.Text = textBox_text.Text;
        }

        private void numericUpDown_velikost_ValueChanged(object sender, EventArgs e)
        {
            kontrolka.Font = new Font(kontrolka.Font.SystemFontName, (float)numericUpDown_velikost.Value, kontrolka.Font.Style);
        }

        private void checkBox_tucne_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox_tucne.Checked)
                NastavFont(true, kontrolka.Font.Italic, kontrolka.Font.Underline, kontrolka.Font.Strikeout);
            else
                NastavFont(false, kontrolka.Font.Italic, kontrolka.Font.Underline, kontrolka.Font.Strikeout);
        }

        private void checkBox_kurziva_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox_kurziva.Checked)
                NastavFont(kontrolka.Font.Bold, true, kontrolka.Font.Underline, kontrolka.Font.Strikeout);
            else
                NastavFont(kontrolka.Font.Bold, false, kontrolka.Font.Underline, kontrolka.Font.Strikeout);
        }

        private void checkBox_podtrzeni_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox_podtrzeni.Checked)
                NastavFont(kontrolka.Font.Bold, kontrolka.Font.Italic, true, kontrolka.Font.Strikeout);
            else
                NastavFont(kontrolka.Font.Bold, kontrolka.Font.Italic, false, kontrolka.Font.Strikeout);
        }

        private void checkBox_preskrtnuti_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox_preskrtnuti.Checked)
                NastavFont(kontrolka.Font.Bold, kontrolka.Font.Italic, kontrolka.Font.Underline, true);
            else
                NastavFont(kontrolka.Font.Bold, kontrolka.Font.Italic, kontrolka.Font.Underline, false);
        }

        //------------------------------------------------------------------------------------Vlastni metody
        private void NastavFont(bool tucne, bool kurziva, bool podtrzeni, bool preskrtnuti)
        {
            Font novyFont = null;

            // bohuzel lepsi zpusob me nenapadl :/
            //NIC---
            if (!tucne && !kurziva && !podtrzeni && !preskrtnuti)
                novyFont = new Font(kontrolka.Font, FontStyle.Regular);


            //JEDNA---
            if (tucne && !kurziva && !podtrzeni && !preskrtnuti)
                novyFont = new Font(kontrolka.Font, FontStyle.Bold);
            if (!tucne && kurziva && !podtrzeni && !preskrtnuti)
                novyFont = new Font(kontrolka.Font, FontStyle.Italic);
            if (!tucne && !kurziva && podtrzeni && !preskrtnuti)
                novyFont = new Font(kontrolka.Font, FontStyle.Underline);
            if (!tucne && !kurziva && !podtrzeni && preskrtnuti)
                novyFont = new Font(kontrolka.Font, FontStyle.Strikeout);


            //DVOJICE---
            // tucne
            if (tucne && kurziva && !podtrzeni && !preskrtnuti)
                novyFont = new Font(kontrolka.Font, FontStyle.Bold | FontStyle.Italic);
            if (tucne && !kurziva && podtrzeni && !preskrtnuti)
                novyFont = new Font(kontrolka.Font, FontStyle.Bold | FontStyle.Underline);
            if (tucne && !kurziva && !podtrzeni && preskrtnuti)
                novyFont = new Font(kontrolka.Font, FontStyle.Bold | FontStyle.Strikeout);
            // kurziva
            if (!tucne && kurziva && podtrzeni && !preskrtnuti)
                novyFont = new Font(kontrolka.Font, FontStyle.Italic | FontStyle.Underline);
            if (!tucne && kurziva && !podtrzeni && preskrtnuti)
                novyFont = new Font(kontrolka.Font, FontStyle.Italic | FontStyle.Strikeout);
            // podtrzeni
            if (!tucne && !kurziva && podtrzeni && preskrtnuti)
                novyFont = new Font(kontrolka.Font, FontStyle.Underline | FontStyle.Strikeout);


            //TROJICE---
            if (tucne && kurziva && podtrzeni && !preskrtnuti)
                novyFont = new Font(kontrolka.Font, FontStyle.Bold | FontStyle.Italic | FontStyle.Underline);
            if (tucne && kurziva && !podtrzeni && preskrtnuti)
                novyFont = new Font(kontrolka.Font, FontStyle.Bold | FontStyle.Italic | FontStyle.Strikeout);
            if (tucne && !kurziva && podtrzeni && preskrtnuti)
                novyFont = new Font(kontrolka.Font, FontStyle.Bold | FontStyle.Underline | FontStyle.Strikeout);
            if (!tucne && kurziva && podtrzeni && preskrtnuti)
                novyFont = new Font(kontrolka.Font, FontStyle.Italic | FontStyle.Underline | FontStyle.Strikeout);

            //CTVERICE---
            if (tucne && kurziva && podtrzeni && preskrtnuti)
                novyFont = new Font(kontrolka.Font, FontStyle.Bold | FontStyle.Italic | FontStyle.Underline | FontStyle.Strikeout);

            kontrolka.Font = novyFont;
        }
    }
}
